procedure CharEd;

{--------------------------------------------------------------------------
28.06.87
                          C H A R E D . I N C
                            ( Vers. Cu/1.1 )
 Prozedur zum Editieren und Laden von benutzerdef. Zeichen fuer den DMX80

                            Wolfgang Tesch
(mit tatkraeftiger Unterstuetzung durch Software des MTX-UserClubs Dtschl.)
                               13-02-86
 --------------------------------------------------------------------------}


{ PrintCh uebernommen aus Window2.inc }

procedure PrintCh(ch:char);
var i:Integer;

    procedure VorigeZeile;
    begin
      if yd>Oben then
        yd := yd-1
    end;

    procedure NaechsteZeile;
    begin
      if yd<Unten then
        yd := yd+1
        else yd := oben;
    end;

begin   (* Print *)
  case ch of
     ^M : begin
            xd:=Links;
            NaechsteZeile;
            gotoxy(xd,yd);
          end;
     ^X : begin
            NaechsteZeile;
            gotoxy(xd,yd);
          end;
  ^S,^H : begin
            if xd>Links then
              xd := xd-1
            else begin
              xd := Rechts;
              VorigeZeile   ;
            end;
            gotoxy(xd,yd);
          end;
     ^E : begin
            VorigeZeile;
            gotoxy(xd,yd);
          end;
 #32,^D : begin
            if ch = #32 then write(ch);
            if xd<Rechts then
              xd := xd+1
            else begin
              xd := Links;
              NaechsteZeile;
            end;
            gotoxy(xd,yd);
          end
  else begin
     write(ch);
     gotoxy(xd,yd);
   end  (* else *)
   end  (* case *)
end;   (* Print *)


{-------------------------------------------------------------------------
                         F I L E N A M E . I N C
                  3 Routinen zum Umgang mit Filenamen
 -------------------------------------------------------------------------}

function UpCaseStr(var Line: DateiNam): DateiNam;
         var i: byte;
         Satz:  DateiNam;
         begin
               Satz:=Line;
               for i:=1 to length(Line) do Satz(.i.):=Upcase(Satz(.i.));
               UpCaseStr:=Satz
         end;


function FileName(fext: DateiExt): DateiNam;
         var fname: DateiNam;
             i:     integer;
         begin
               read(fname);
               for i:=1 to length(fname) do write(chr(8));
               while pos(' ',fname)>0 do
                     delete(fname,pos(' ',fname),1);
               if pos('.',fname)=0 then
                  fname:=concat(fname,'.',fext);
               write(UpCaseStr(fname),chr(5));
               FileName:=fname;
         end;


function FileExists(var datei: DateiNam): boolean;
         var d: text;
             i: boolean;
         begin
               assign(d,datei);
               {$I-}
               reset(d);
               FileExists:=(IOresult=0);
               close(d);
               i:=(IOresult=0);
               {$I+}
         end;

procedure Weiter;
begin
  OpenWindow(70,17,8,5,true);
  gotoxy(1,1);write('Weitermit   <RET>');
  readln;
  CloseWindow;
end;

procedure Help;
begin
  OpenWindow(10,10,60,10,true);
  gotoxy(1,1);
  writeln('Im "Zeichen"-Fenster kann das Punktmatrix-Muster f}r ein ');
  writeln('Zeichen erstellt werden.');
  writeln('  Steuerungsm|glichkeiten: ');
  writeln(' ');
  write('eine Spalte nach links : ');
  writeln(#25#27'G','H',#27'S');
  write('eine Spalte nach rechts: ');
  writeln(#25#27'G','I',#27'S');
  write('eine Zeile nach unten  : ');
  writeln(#25#27'G','J',#27'S');
  write('eine Zeile nach oben   : ');
  writeln(#25#27'G','K',#27'S');
  gotoxy(31,4);write('Bel. Taste (au~er <SPACE>,?,');
  gotoxy(31,5);write('<ESC>,"Pfeil"-Tasten) setzt');
  gotoxy(31,6);write('Punkt, <SPACE> l|scht Punkt.');
  gotoxy(31,7);write('<ESC>, wenn Zeichen fertig.');
  weiter;
  CloseWindow;
end;


procedure Editieren(var ZeichFile:ZeichFileTy);

type ZeichArrayTy = array[1..63] of ZeichTy;

const Leer : ZeichTy = ( Code: 0;
                         Muster: (0,0,0,0,0,0,0,0,0));

var Zeichen : ZeichTy;
    ZeichArray : ZeichArrayTy;
    ZeichNr : byte;
    Datei : DateiNam;
    ind,ix : byte;
    Ende : boolean;
    Offset : byte;

{--------------------------------------------------------------------------
                         B I T M A N I P . P R C
         3 Routinen zum Manipulieren bzw. Testen von einzelnen Bits
- Ist Bit n von x gesetzt ?
  function TestBit ( var x ; n : byte ) : boolean;
- Setze Bit n von x
  procedure SetBit ( var x; n : byte ) ;
- Loesche Bit n von x
  procedure ResBit ( var x; n : byte);

Parameter:
x        -> x enthaelt den Wert, der veraendert oder getestet werden soll
            Da x nicht typisiert ist, kann der aktuelle Parameter fuer x
            von einem beliebigen Typ mit max. 2 Byte Laenge sein.
            (z.B. byte, char, integer, pointer, selbstdef. Skalare )
n : byte -> Nummer des betroffenen Bits ( 0..15 )
            (bei Typen von Byte-Groesse ist n > 7 nicht def. )
-----------------------------------------------------------------------------}

function TestBit ( var x ; n : byte ) : boolean;
{ ist Bit n von x gesetzt ? }
var wert : integer absolute x;
begin
  TestBit := (wert and ( 1 shl n )) <> 0;
end;

procedure SetBit ( var x; n : byte ) ;
{ setze Bit n von x }
var wert : integer absolute x;
begin
  wert := wert or ( 1 shl n );
end;

procedure ResBit ( var x; n : byte);
{ setze Bit n von x zurueck }
var wert : integer absolute x;
begin
  wert := wert and ( $FFFF xor ( 1 shl n));
end;

procedure HoleCode (var Zeichen:ZeichTy;var ZeichArray:ZeichArrayTy;
                    var ZeichNr : byte;var Ende:boolean);
var Zeich : char;
    ASCII : byte;
    NumStr: string[6];
    gueltig:boolean;

procedure SucheZeichen (var Zeichen:ZeichTy;var ZeichArray:ZeichArrayTy;
                        var ZeichNr:byte);
var AktZeich:ZeichTy;
begin
  ZeichNr := 0;
  repeat
    ZeichNr := succ(ZeichNr);
    AktZeich := ZeichArray[ZeichNr];
  until (AktZeich.Code = 0) or
        (AktZeich.Code = Zeichen.Code);
  Zeichen.Muster:=AktZeich.Muster;
end;

begin
  openwindow(40,10,27,10,true);
  gotoxy(3,2);
  write('Taste  des  Zeichens     dr}cken ,  das  neu    ');
  write('  definiert werden soll  ');
  write('-------------------------');
  gotoxy(5,6);write('<ESC> zum Beenden');
  gotoxy(2,7);write('^C   zum Bereichwechsel');
  repeat
    read(KBD,Zeich);
    if Zeich = ^C then
      begin
        Offset := (Offset + 128) mod 256;
        ChangeWindow(4);
        gotoxy(11,2);
        Str(Offset:3,NumStr); write(NumStr);
        ChangeWindow(5);
      end;
    gueltig := ord(Zeich) > 32;
    Ende    := Zeich = #27;
  until Ende or gueltig;
  closewindow;
  if not Ende then
  begin
    ASCII := Offset+ord(Zeich);
    Zeichen.Code := ASCII;
    SucheZeichen(Zeichen,ZeichArray,ZeichNr);
    Ende := Ende or (ZeichNr > 62);
    if not ende
    then begin
      openwindow(40,10,21,10,true);
      gotoxy(1,1);
      write(' Folgendes Zeichen  wird umdefiniert:');
      gotoxy(5,4);
      write('"'+Zeich+'" + ');
      Str(Offset,NumStr); write(NumStr);
      gotoxy(5,5);
      write('Code: ');
      Str(ASCII,NumStr);
      write(NumStr);
      gotoxy(1,6);write('-------------------');
      gotoxy(1,7);write(' <ESC> zum Beenden');
      gotoxy(1,8);write(' "?" f}r Help-Info')
      end
    else begin
      OpenWindow (30,10,32,5,true);
      gotoxy (2,2);
      write('bereits 62 Zeichen definiert');
      write(#7);
      Weiter;
      CloseWindow;
    end;
  end;
end;


procedure EditZeichen (var Zeichen:ZeichTy);
const Adr = $F40B;
      ScrPeek=#27'R';
var ch : char;
    ix,jy:byte;
    Wert :byte;
    Test : byte;

procedure SchreibMuster(var Zeichen:ZeichTy);
var ix,jy : byte;
    Wert : byte;
begin
  for ix := 0 to 8 do
  begin
    Wert := Zeichen.Muster[ix];
    for jy := 0 to 7 do
    begin
      gotoxy(1+ix,1+jy);
      if TestBit(Wert,7-jy)
        then PrintCh('*')
        else PrintCh(' ');
    end;
  end;
end;

begin
 OpenWindow(12,10,11,10,true);
 Oben := 1; Links := 1; Rechts := 9; Unten := 8;
 xd := 1; yd := 1;
 writeln(#29);
 repeat
  Test := 0;
  SchreibMuster(Zeichen);
  gotoxy(xd,yd);
  read(KBD,ch);
  while ch <> #27 do
  begin
    if ch='?' then Help
    else if ch < #33 then
       begin
          if (ch = ^D) or (ch = ^X) or (ch = ^E)
          or (ch = ^H) or (ch = ^S) or (ch = ^M)
            then PrintCh(ch)
          else PrintCh(' ')
       end
    else PrintCh('*');
    read(KBD,ch);
  end;
  for ix := 0 to 8 do
  begin
    Wert := 0;
    for jy := 0 to 7 do
    begin
      gotoxy(links+ix,oben+jy);
      write(ScrPeek);
      if mem[Adr] <> 32 then SetBit(Wert,7-jy);
    end;
    Zeichen.Muster[ix] := Wert;
    if ix > 0 then Test := Test or (Wert and Zeichen.Muster[ix-1]);
  end;
  if Test <> 0 then
    begin
      OpenWindow(25,12,30,5,true);
      gotoxy(2,2);write('ung}ltige Punktkombination');
      Write(^G);Weiter;
      CloseWindow;
    end;
 until Test = 0;
end;



begin
  Offset := 128;
  OpenWindow(19,1,32,9,true);
  gotoxy(8,1);write('C h a r E d');
  gotoxy(8,2);write('-----------');
  gotoxy(3,3);write('Zeichensatz editieren');
  gotoxy(3,4);
  write('Dateiname = ');
  Datei := FileName('CHR');
  Datei := UpCaseStr(Datei);
  writeln;
  if FileExists(Datei)
    then begin
      writeln;writeln('  Zeichendatei wird geladen');
      assign(ZeichFile,Datei);
      reset(ZeichFile);
      for Ind := 1 to 63 do
        read(ZeichFile,ZeichArray[Ind]);
      close(ZeichFile);
    end
    else begin
      writeln;writeln('  Neue Zeichendatei');
      assign(ZeichFile,Datei);
      for Ind := 1 to 63 do ZeichArray[Ind] := Leer;
    end;
  {  write(#13,#11,#11,#5,#10,#5);}
  Ende := false;
  OpenWindow(55,3,23,4,true);
  gotoxy(2,1);write('Datei= ');write(Datei);
  gotoxy(2,2);write('Offset = 128');
  while not Ende do
  begin
    HoleCode(Zeichen,ZeichArray,ZeichNr,Ende);
    if not Ende then
    begin
      EditZeichen(Zeichen);
      ZeichArray[ZeichNr] := Zeichen;
      CloseWindow;CloseWindow;
    end;
  end;
  gotoxy(5,10);
  writeln('Zeichendatei wird auf Diskette gespeichert');
  rewrite(ZeichFile);
  for Ind := 1 to 63 do
    write(ZeichFile,ZeichArray[Ind]);
  close(ZeichFile);
  CloseWindow; CloseWindow;
end;


procedure DruckerLaden (var ZeichFile : ZeichFileTy);
var Zeich : ZeichTy;
    Ind   : byte;
    Datei : DateiNam;


function LiesParam (fext: DateiExt): DateiNam;
 var fname: DateiNam;
         i: integer;
 begin
   fname := ParamStr(1);
   while pos(' ',fname)>0 do
     delete(fname,pos(' ',fname),1);
   if pos('.',fname)=0 then
     fname:=concat(fname,'.',fext);
    write(UpCaseStr(fname),chr(5));
    LiesParam :=fname;
  end;


begin
  OpenWindow(2,1,29,10,true);
  gotoxy(9,2);write('C h a r E d');
  gotoxy(9,3);write('-----------');
  gotoxy(2,4);writeln('Drucker mit Zeichen laden');
  gotoxy(5,10);
  write('Dateiname = ');
  if ParamCount > 0
    then Datei := LiesParam('CHR')
    else Datei := FileName('CHR');
  writeln;
  if FileExists(Datei)
    then begin
      assign(ZeichFile,Datei);
      reset(ZeichFile);
      writeln(' Zeichen-Codes werden an    den Drucker uebertragen');
      read(ZeichFile,Zeich);
      while (Zeich.Code <> 0 ) do
        begin
          write(LST,chr(27),'Y',chr(Zeich.Code));
          for ind := 0 to 8 do write(LST,chr(Zeich.Muster[Ind]));
          read(ZeichFile,Zeich);
        end;
      Weiter;
      close(ZeichFile);
    end
    else begin
      writeln;writeln(' Gew}nschte Datei nicht     gefunden. ');
      write(#7); Weiter;
    end;
    CloseWindow;
  end;

procedure Titel;
procedure WrLine(Line:AnyStr);
var i:byte;
begin
  for i := 1 to length(Line) do
    if Line[i] = ' '
      then write(' ')
      else write(#127);
end;

begin
  OpenWindow(24,3,35,11,true);
  gotoxy(1, 1);WrLine('****  *                ****     *');
  gotoxy(1, 2);WrLIne('*     *                *        *');
  gotoxy(1, 3);WrLine('*     ****  ****  ***  ***   ****');
  gotoxy(1, 4);WrLine('*     *  *  *  *  *    *     *  *');
  gotoxy(1, 5);WrLine('****  *  *  ***** *    ****  ****');writeln;
  write('Editieren und Laden von benutzer-');
  write('definierten Zeichen f}r den DMX80');
  write('      (W.Tesch/P.W}rfel )');
  OpenWindow(29,15,22,7,true);
  gotoxy(6,2);write('E = Editieren');
  gotoxy(6,3);write('L = Laden');
  gotoxy(2,4);write('<ESC> = Beenden');
end;

begin
   repeat
   Titel;
      repeat
         read(KBD,Ch);
         Ch := upcase(Ch);
      until Ch in ['E','L',#27];
      CloseWindow;CloseWindow;
      case Ch of
         'E' : Editieren(ZeichFile);
         'L' : DruckerLaden(ZeichFile);
      end;
   until Ch = #27;
end;

