(* Copyright by                B}ro f}r angewandte Datentechnik   1987     *)
(* diese Texte d}rfen f}r nichtkommerzielle Zwecke frei kopiert werden     *)

Function killblanks ( f:Anystring ) : Anystring;

(*********************************************************************)
(* Entfernt alle Spaces aus einem String, gleichzeitig Wandlung in   *)
(* Gro~buchstaben                                                    *)
(*********************************************************************)

var i,n : integer;

Begin
  n := 1;
  for i := 1 to length(f) do
    if f(.i.) <> ' ' then
    Begin
      f(.n.) := Upcase(f(.i.));
      n := Succ(n)
    End;
  killblanks := copy( f,1,n-1 )
End;

(*$A- *)
Function Hoch( x : Real; y : Integer) : Real;

(**************************************************************************)
(* Potenzfunktion :  Eingang x ist Basis, y ist Exponent;  Ausgang : x^y  *)
(**************************************************************************)

Begin
  If y = 0 then Hoch := 1
           else if y > 0 then Hoch := x * Hoch( x,y-1)
                         else Hoch := 1 / Hoch( x,-y )
End;
(*$A+ *)

Function Check_Expression(Var Ausdruck,Zeile : Anystring ) : Boolean;

(***************************************************************************)
(* Pr}ft einen Ausdruck auf syntaktische Korrektheit.                      *)
(* Eingang : Ausdruck (max 255 Zeichen) und Dummystring f}r Fehlermeldung  *)
(* Ausgang : true wenn OK, false sonst                                     *)
(*           wenn false, enth{lt der Dummystring die Fehlermeldung         *)
(*                       und in Ausdruck ist an der Fehlerposition         *)
(*                       ein '#' eingef}gt                                 *)
(* Ruft die Function Killblanks auf !!                                     *)
(***************************************************************************)

Const Digits     : Set of Char =(.'0'..'9'.);
      Vorzeichen : Set of Char =(.'+','-'.);
      Exponent   : Set of Char =(.'E','e'.);
      Letter     : Set of Char =(.'A'..'Z','a'..'z','_'.);
      Errtext    : Array(.1..2.) of String(.80.) =  ('Fehler : ','');

Type Typen     = (Bekannt,Funktion,Unbekannt);
     Setofchar = Set of Char;

Var Ch           : Char;
    p,l,position : Integer;
    sym          : Str20;
    Fehlerflag   : Boolean;

Procedure Error;
Begin
  Write(Chr(7));
  insert('#',Ausdruck,Position);
  Zeile := Errtext(.1.)+Errtext(.2.);
  Check_Expression := false;
End;

Procedure Err( text : Anystring );
Begin
  if not Fehlerflag then
  Begin
    Fehlerflag := true;
    Errtext(.2.) := text;
    Position   := Pred(p)
  End
End;

Procedure Readchar;
Begin
  if p <= l then ch := Ausdruck(. p .)
            else ch := Chr(3);
   p := succ( p )
End;

Procedure Readsym( Okset : Setofchar);
Begin
  sym :='';
  While ch in Okset do
  Begin
    sym := sym + ch;
    Readchar
  End
End;

Function Check_Identifier : Typen;

(****************************************************************************)
(* Wichtig f}r Erweiterungen !!                                             *)
(* hier m}ssen in Liste1 alle bekannten Variablen,Konstanten eingef}gt      *)
(* werden, in Liste2 alle bekannten Funktionen.                             *)
(* n und m m}ssen nat. auch angepasst werden.                               *)
(* Das was's !                                                              *)
(****************************************************************************)

Const n = 6;
      Liste1 : Array(.1..n.) of String(.4.) =
             ('XO','YO','YC','M','X','PI');   (* Var's und Konstanten *)
      m = 5;
      Liste2 : Array(.1..m.) of String(.4.) =
              ('SIN','COS','TAN','SQRT','SQR');  (* Funktionen *)

Var Index    : Byte;
    Art      : Typen;
Begin
  Art := Unbekannt;
  For Index := 1 to n do if sym = Liste1(.Index.) then Art := Bekannt;
  If Art = Unbekannt then
  Begin
    For Index := 1 to m do
      If sym = Liste2(.Index.) then Art := Funktion
  End;
  Check_Identifier := Art
End;

Function Number : Boolean;
Type Zahlstring = Str20;
var zahl,zahl1  : Zahlstring;
    kein_Fehler : Boolean;
    Nummer      : Real;
    i           : integer;

  Procedure Test( Z : Zahlstring);
  Begin
    if ( Z='') or (Z='+') or (Z='-') then Kein_Fehler := False
                                     else Kein_fehler := True
  End;

  Procedure Add(Var Z : Zahlstring; Ch : Char);
  Begin
    Z := Z + Ch;
    Readchar
  End;

  Function Unsigned_Integer : Zahlstring;
  Begin
    Readsym( Digits );
    Unsigned_Integer := sym
  End;

  Function Signed_Integer : Zahlstring;
  Var Zahl : Zahlstring;
  Begin
    Zahl := '';
    If ch in Vorzeichen then Add(Zahl,ch);
    Signed_Integer :=Zahl + Unsigned_Integer
  End;

Begin
  Kein_Fehler := True;
  Zahl := Signed_Integer;
  If ch = '.' then
  Begin
    Add(Zahl,Ch);
    Zahl1 := Unsigned_Integer;
    Zahl := Zahl + Zahl1;
    Test(Zahl1);
  End;
  If ch in Exponent then
  Begin
    Add(Zahl,ch);
    Zahl1 := Signed_Integer;
    Zahl := Zahl + Zahl1;
    Test(Zahl1)
  End;
  Test(Zahl);
  Number := Kein_Fehler;
End;

(*$A-*)
Procedure Expression;

  Procedure Factor;
  Var Art : Typen;
  Begin
    if ch in Letter then
    begin
      Readsym(Letter + Digits);
      Art := Check_Identifier;
      if Art = Unbekannt then Err('Groesse nicht bekannt !');
      if (Art = Funktion) and (Ch <> '(') then Err('( erwartet !');
      if  (ch='(') then
      begin
        if Art <> Funktion
          then Err('Funktion erwartet !')
          else Begin
                 Expression;
                 if ch <>')' then Err(') fehlt !')
                             else readchar
                End
      End
    End
    else if ch in (Vorzeichen + Digits + (.'.'.))
         then Begin if not Number then Err('falsche Zahl !') End
         else if Ch = '(' then
              Begin
                Expression;
                if ch <> ')' then Err(') fehlt !')
                             else Readchar
               End
               else Err('Syntax nicht eingehalten !')
  End;

  Procedure Term;
  Begin
    Factor;
    While ch in (.'*','/','^'.) do Begin Readchar; Factor End
  End;

Begin
  Readchar;
  if ch in Vorzeichen then Readchar;
  Term;
  While ch in Vorzeichen do Begin Readchar;Term End
End;
(*$A+*)

Begin
  Fehlerflag := false;
  Zeile := '';
  Ausdruck := killblanks(Ausdruck);
  l := Length(Ausdruck);
  p := 1;
  Expression;
  if (p-2) <> l
   then Err('Ausdruck nicht vollstaendig ausgewertet !');
  if Fehlerflag then Error;
  Check_Expression := not Fehlerflag
End;


Function Konvert( f : Anystring ) : Ptr;

(********************************************************************)
(* Wandelt einen syntaktisch korrekten Ausdruck in einen Baum um.   *)
(* Eingang : String bis 255 L{nge,                                  *)
(* Ausgang : Zeiger auf Wurzel.                                     *)
(* Priorit{t der Rechenzeichen wie gewohnt. +,-,*,/,^               *)
(********************************************************************)

{$a-}

function search ( f:Anystring ) : integer;
const Ops : set of char = (.'+','-','*','/','^'.);        (* Rechenzeichen *)
var i,kl,p,art : integer;
    r          : real;
Begin
  p   := 0;  kl  := p;  art := 6;
  val(f,r,i);
  if not( f(.1.) in (.'+','-'.)) or (i <> 0) then
  Begin
    for i := length(f) downto 1 do
    Begin
      case f(.i.) of
         ')' : kl := Succ(kl);
         '(' : kl := Pred(kl);
      End;
      if kl = 0 then
      case f(.i.) of
         '+' : if (art > 1) and (f(.Pred(i).) <> 'E')
                                             then begin p := i; art := 1 End;
         '-' : if (art > 2) and (f(.Pred(i).) <> 'E')
                                             then begin p := i; art := 2 End;
         '*' : if art > 3 then begin p := i; art := 3 End;
         '/' : if art > 4 then begin p := i; art := 4 End;
         '^' : if art > 5 then begin p := i; art := 5 End;
      End
    End;
    if f(.Pred(p).) in Ops then p := Pred(p)
  End;
  search := p
End;

function konst ( c:Str20 ) : ptr;
var Baum : ptr;
Begin
  new(Baum);
  Baum^.l := nil;
  Baum^.r := nil;
  if c <> '' then Baum^.Wert := c
             else Baum^.Wert := '0';
  konst := Baum;
End;

function add ( sign : Str20; u,v : ptr ) : ptr;
var Baum : ptr;
Begin
  new(Baum);
  Baum^.l := u;
  Baum^.r := v;
  Baum^.wert := sign;
  add := Baum;
End;

function Convert ( f:Anystring ) : ptr;
var k,p : integer;
    b   : Boolean;

Begin
  repeat
    b := true;
    k := pos('(',f);
    p := search(f);
    if (p = 0) and (f(.1.) = '(') and (f(.length(f).) = ')') then
    Begin
      f := copy(f,2,length(f)-2);
      b := false
    End;
  until b;
  if (k=0) and (p=0) then convert := konst(f)
  else
    if p=0 then convert := add(copy(f,1,k-1),
                               convert(copy(f,k+1,length(f)-k-1)),
                               nil)
    else
      convert := add(concat(f(.p.),''),
                     convert(copy(f,1,p-1)),
                     convert(copy(f,p+1,length(f)-p)))
End;

Begin
  konvert  := convert( Killblanks( f ) );
End;
(*$A+ *)


Procedure Make_calculator( Fkt : Anystring );

(**********************************************************************)
(* macht aus einem syntaktisch korrekten String eine Vorschrift,      *)
(* wie auf den Registern gerechnet werden soll.                       *)
(* Ruft die Funktion Konvert auf !!                                   *)
(* Belegt im Record 'Ergebnisse' die Werte ANO und ERNO, d.h.         *)
(*   ANO  = max. Zahl Anweisungsregister                              *)
(*   ERNO = max. Zahl Ersetzungsregister d.h Register in denen 'X'    *)
(*          durch einen Wert ersetzt werden soll.                     *)
(* Im Array ERSETZEN werden alle Rechenregister  aufgez{hlt, in denen *)
(* die Variable X durch einen Wert ersetzt werden soll.               *)
(**********************************************************************)

Var Ano,Ano1,Erno,Rno : Byte;

Function What( Ex : Str20 ) : Operation;

(********************************************************)
(* erkennt aus dem ]bergebenen String, welcher Operator *)
(* oder Operand gemeint ist                             *)
(********************************************************)

Var Code : Integer;
    xx   : Real;
Begin
  Val(Ex,xx,Code);
  If (Code <> 0) or ((Length(Ex) = 1) and (Ex(.1.) in (.'+','-'.))) then
  Begin
    Case Ex(. 1 .) of
      '+'  : What := add;
      '-'  : What := dif;
      '*'  : What := mult;
      '/'  : What := times;
      '^'  : What := pot;
      'M'  : What := mb;
      'P'  : What := pib;
      'X'  : Begin
               If Ex = 'X'
                then What := xb
                else What := xob;
             End;
      'Y'  : Begin
               If Ex = 'YO'
                then What := yob
                else What := ycb;
             End;
      'T'  : What := tanx;
      'C'  : What := cosx;
      'S'  : Case Ex(. 2 .) of
              'I' : What := sinx;
              'Q' : Begin
                      If Ex = 'SQR'
                       then What := sqrx
                       else What := sqrtx;
                    End;
             End;
    End;
  End
  else What := num;
End;

Function Wert( Ex : Str20; Op : Operation ) : Real;

(************************************************************************)
(* Gibt wen Wert des Operanden Op zur}ck, war's eine Konstante, so wird *)
(* sie aus ERGEBNISSE geholt, eine Zahl wird direkt gewandelt           *)
(************************************************************************)

Var i : Integer;
    xx: Real;
Begin
  With Ergebnisse do
  Begin
    Case Op of
      mb   : Wert := m;
      xob  : Wert := xo;
      yob  : Wert := yo;
      ycb  : Wert := yc;
      pib  : Wert := pi;
      num  : Begin
               Val(Ex,xx,i);
               Wert := xx
             End
   End;
 End
End;

(*$A- *)
Procedure Translate( Zeiger : Ptr; Ano : Byte);
Var Op : Operation;
Begin
  Op := What( Zeiger^.wert );
  Case Op of                     (* zweistelline Operationen *)
    add,dif,mult,
         times,pot : Begin
                       Ano1 := Succ(Ano1);
                       Calc(. Ano .).op := Op;
                       Calc(. Ano .).r3 := Rno;
                       Rno := Succ(Rno);
                       Calc(. Ano .).r1 := Rno;
                       Translate( Zeiger^.l,Succ(Ano));
                       Rno := Succ( Rno );
                       Calc(. Ano .).r2 := Rno;
                       Translate( Zeiger^.r,Succ(Ano1))
                     End;
    sinx,cosx,tanx,                             (* einstellige Operationen *)
    sqrtx,sqrx      : Begin
                        Ano1 := Succ(Ano1);
                        Calc(. Ano .).op := Op;
                        Calc(. Ano .).r3 := Rno;
                        Rno := Succ( Rno );
                        Calc(. Ano .).r1 := Rno ;
                        If Zeiger^.l <> nil
                         then Translate( Zeiger^.l,Succ(Ano))
                         else Translate( Zeiger^.r,Succ(Ano))
                      End;
     num,xob,yob,                                 (* Konstanten *)
     ycb,mb,pib      : Register(. Rno .) := Wert( Zeiger^.wert,Op );

     xb              : Begin                      (* Variable X *)
                        Erno := Erno + 1;
                        Ersetzen(. Erno .) := Rno
                      End;
  End;
End;
(*$A+ *)

Begin
  Erno := 0;
  Ano1 := 0;
  Rno  := 1;
  Translate( Konvert( Fkt ),1);
  Ergebnisse.Ano  := Ano1;
  Ergebnisse.Erno := Erno;
End;


Function Benutzer_wert( x : Real ): Real;

(************************************************************************)
(* rechnet aus der in 'Make_Calculator' erzeugten Rechenvorschrift den  *)
(* Funktionswert des Ausdruck's aus                                     *)
(* Zuerst werden alle Register belegt, die den Wert der Variablen X     *)
(* erhalten sollen, dann werden alle Anweisungsregister abgeklappert    *)
(* dem Inhalt entsprechend die Operanden verkn}pft                      *)
(* Beliebige neue Funktionen sind vorstellbar, m}ssen dann aber im      *)
(* Aufz{hltyp OPERATION , in den Funktionen WHAT, TRANSLATE und evtl.   *)
(* in WERT eingebaut werden. Wenn Syntaxcheck durchgef}hrt werden soll, *)
(* mu~ auch Check_Expression angepasst werden.                          *)
(************************************************************************)

Var i : Byte;
Begin
  For i := 1 to Ergebnisse.Erno do Register(. Ersetzen(.i.).) := x;
  For i := Ergebnisse.Ano downto 1 do
  Case Calc(.i.).Op of
    add  : Register(.Calc(.i.).r3.) :=
           Register(.Calc(.i.).r1.)  +  Register(.Calc(.i.).r2.);
    dif  : Register(.Calc(.i.).r3.) :=
           Register(.Calc(.i.).r1.)  -  Register(.Calc(.i.).r2.);
    mult : Register(.Calc(.i.).r3.) :=
           Register(.Calc(.i.).r1.)  *  Register(.Calc(.i.).r2.);
    times: Register(.Calc(.i.).r3.) :=
           Register(.Calc(.i.).r1.)  /  Register(.Calc(.i.).r2.);
    pot  : Register(.Calc(.i.).r3.) :=
           Hoch(Register(.Calc(.i.).r1.),Trunc(Register(.Calc(.i.).r2.)));
    sinx : Register(.Calc(.i.).r3.) := sin( Register(.Calc(.i.).r1.) );
    cosx : Register(.Calc(.i.).r3.) := cos( Register(.Calc(.i.).r1.) );
    tanx : Register(.Calc(.i.).r3.) := sin( Register(.Calc(.i.).r1.) )
                                       / cos( Register(.Calc(.i.).r1.));
    sqrtx: Register(.Calc(.i.).r3.) := sqrt ( Register(.Calc(.i.).r1.) );
    sqrx : Register(.Calc(.i.).r3.) := sqr  ( Register(.Calc(.i.).r1.) );
  End;
  Benutzer_Wert := Register(.1.)
End;