(* Copyright by                B}ro f}r angewandte Datentechnik   1987     *)
(* diese Texte d}rfen f}r nichtkommerzielle Zwecke frei kopiert werden     *)


Program Rechne_Funktionen_aus ( Input,Output );

(********************************************************************)
(* Alle Typdeklarationen m}ssen im Hauptprogramm vorgenommen werden *)
(********************************************************************)

Type Anystring       = String(.255.);
     Str20           = String(.20.);
     SetOfChar       = Set of Char;
     Ptr             = ^Element;
     Element         = Record
                         Wert : Str20;
                         l,r  : Ptr;
                       End;

     Operation       = (add,dif,mult,times,pot,sinx,cosx,tanx,
                        sqrx,sqrtx,num,xb,mb,xob,yob,ycb,pib);

(***************************************************************************)
(* Operationen ist sehr wichtig, hier werden alle zugelassenen Operationen *)
(* eingebaut. Die Bedeutung ist :                                          *)
(*    Bezeichner       Bedeutung      Rechenzeichen                        *)
(*      add            Addition            +                               *)
(*      dif            Differenz           -                               *)
(*      mult           Multiplikation      *                               *)
(*      times          Division            /                               *)
(*      pot            Potenz              ^                               *)
(*      sinx           Sinus               SIN()   (sinx wegen Unterschied *)
(*                                                   zu PASCAL-Statement)  *)
(*      cosx           Cosinus             COS()                           *)
(*      tanx           Tangens             TAN()                           *)
(*      sqrx           Quadrat             SQR()                           *)
(*      sqrtx          Quadratwurzel       SQRT()                          *)
(*      num            Relle Zahl          Bsp: +1234.234E-2               *)
(*      xb,mb,xob,                                                         *)
(*      yob,ycb        Variablen           X,M,XO,YO,YC (werden im         *)
(*                                         VariablenRecord gespeichert und *)
(*                                         bei der Berechnung eingebaut)   *)
(*      pib            Konstante           PI    (=3.14159265)             *)
(*                                                                         *)
(*   beliebig erweiterbar                                                  *)
(***************************************************************************)

     VariablenRecord = Record
                         m, xo, yo, yc : Real;
                         Ano,Erno      : Integer;
                       End;

(**********************************************************************)
(* VariablenRecord ist der Zwischenspeicher f}r die Variablen, der    *)
(* ]bersetzer holt sich die Werte aus diesem Record und rechnet damit *)
(**********************************************************************)

     Aktion          = Record
                         r1,r2,r3 : Byte;
                         Op       : Operation
                       End;

(**********************************************************************)
(* Aktion gibt die Registerstruktur an, auf der gerechnet wird.       *)
(* Verfahren : r1 und r2 werden durch die Operation OP verkn}pft und  *)
(* in r3 gespeichert.  Dabei sind r1,r2,r3 hier nur Zeiger auf die    *)
(* echten Register im Array 'Register'                                *)
(**********************************************************************)

Const Pi : Real = 3.14159265;

Var Ergebnisse    : VariablenRecord;
    Calc          : Array(.1..50.) of Aktion; (* Speicher f}r Zeiger         *)
    Register      : Array(.1..100.) of Real;  (* Speicher f}r Rechenregister *)
    Ersetzen      : Array(.1..50.) of Byte;   (* Ersetzungsliste             *)
    Ausdruck,
    FehlerString  : AnyString;
    i             : integer;
    x,y           : Real;

(*$I Rechne.inc *)

Begin
  with Ergebnisse do
  Begin
    m  := 1; xo := 1;      (* nicht vergessen die konstanten zu belegen *)
    yo := 1; yc := 1       (* sonst gibt's Unsinn                       *)
  End;
  clrscr;
  writeln('*******   Programm Formelrechner   ********');
  writeln;
  writeln('gebe Ausdruck ein :');
  write('>');
  readln(Ausdruck);
  if Check_Expression(Ausdruck,Fehlerstring)
    then Begin
           writeln('OK, der Ausdruck ist syntaktisch korrekt !');
           Make_Calculator(Ausdruck);
           writeln('Ich rechne jetzt den Ausdruck f}r ein x 1000 mal aus.');
           writeln('Vergleiche die Zeit mit einem programmierten Ausdruck');
           repeat
             write('Gebe x ein (0=Ende) : ');
             read(x);
             if x <> 0 then
             Begin
               write('     Ergebnis : ');
               for i := 1 to 1000 do y := Benutzer_Wert(x);
               writeln(chr(7),y);
             End
           until x = 0
         End
    else Begin
           writeln;
           writeln(FehlerString);
           writeln(Ausdruck);
         End;
End.