(*******************************************************)
(*                                                     *)
(*          WINDOWs f}r MEMOTECH MTX 500/512           *)
(*                                                     *)
(*                   Version 2.00                      *)
(*          lauff{hig unter RAM3 oder neuer            *)
(*                                                     *)
(*        nach einer Idee von Klaus Rindtorff          *)
(*            (Realisation auf APPLE II+)              *)
(*                                                     *)
(*         Version f}r MEMOTECH MTX 500/512            *)
(*              Copyright Olaf Krumnow                 *)
(*                                                     *)
(*    Stand (Version 1.00) : 01.10.85                  *)
(*    Start (Version 2.00) : 04.03.86                  *)
(*    Stand (Version 2.00) : 04.03.86                  *)
(*    Stand Info 20 S.4    : 10.06.87                  *)
(*******************************************************)
(*                                                     *)
(*     Version unabh{ngig von anderen Includefiles     *)
(*                                                     *)
(*******************************************************)

const
      MaxWindow            =  8;
      Auswahl              = 13;
      NachOben             =  5;
      NachUnten            = 24;

type
      WindowElement        = record
        xc0, yc0,
        wb0, wh0,
        wx0, wy0           : byte;
        R                  : boolean; (* true, wenn Rahmen *)
        Buffer             : ^integer
      end;

var
      xc                   : byte absolute $f413;
      yc                   : byte absolute $f414;
      Attribut             : byte absolute $f40e;
      wx, wy, wb, wh       : byte;
      WindowStack          : array(.0..MaxWindow.) of WindowElement;
      Window, Top          : 0..MaxWindow;


procedure SetWindow (x,y,b,h:byte);
begin
  write(#27,'\',chr(x+32),chr(y+32),chr(b+32),chr(h+32))
end;

procedure Zeichne_Rahmen (x,y,b,h:byte);
begin
  write(#27,'O',chr(x+32),chr(y+32),chr(b+32),chr(h+32))
end;

procedure InitWindow;
var Vers:string(.3.);
var i:integer;

   procedure Fehler;
   begin
      writeln(^g'FEHLER: keine oder falsche RAM-Version im Speicher !');
      writeln('Mindestens Version 3.x wird ben|tigt...');
      halt
   end;

begin
  (* Pruefen, ob RAM3 oder neuer im Speicher *)
  Vers := 'RAM3';
  for i:=1 to 3 do
    if chr(mem(.$ffc0+i.))<>Vers(.i.) then Fehler;

  SetWindow(0,0,80,24);   (* ganzen Bildschirm setzen *)
  write(^x);
  ClrScr;
  wx := 0; wy := 0;
  wb := 80; wh := 24;
  Top := 0; Window := 0;

  with WindowStack(.0.) do begin
    xc0 := xc; yc0 := yc;
    wx0 := wx; wy0 := wy;
    wb0 := wb; wh0 := wh
  end;
end;

procedure SaveScreen(x,y,b,h:byte; Buff:integer);
var Pos:integer;
begin
  Pos := y*80 + x;  (* Ergebnis noch in HL *)
  Inline(
    $3a/b/             (*        ld   a,(b)           Breite des Bereiches  *)
    $47/               (*        ld   b,a             nach B                *)
    $3a/h/             (*        ld   a,(h)           H|he                  *)
    $4f/               (*        ld   c,a             nach C                *)
    $ed/$5b/$f411/     (*        ld   de,(0f411h)     VRAM-Startoffset      *)
    $19/               (*        add  hl,de           Cursoradresse         *)
    $ed/$5b/Buff/      (*        ld   de,(Buff)       Bufferadresse         *)

    $c5/               (* Loop1: push bc              Z{hler  retten        *)
    $e5/               (*        push hl              Adresse retten        *)
    $7c/               (* Loop2: ld   a,h             Hi-Byte ausgeben      *)
    $e6/$1f/           (*        and  1f                                     *)
    $d3/$31/           (*        out  (31h),a                               *)
    $7d/               (*        ld   a,l             jetzt Lo-Byte         *)
    $d3/$30/           (*        out  (30h),a         der Adresse raus      *)
    $23/               (*        inc  hl              hochz{hlen            *)
    $db/$32/           (*        in   a,(32h)         Zeichen einlesen      *)
    $12/               (*        ld   (de),a          in Buffer schreiben   *)
    $13/               (*        inc  de              Buffer hochz{hlen     *)
    $db/$33/           (*        in   a,(33h)         Attribut reinholen    *)
    $12/$13/           (*        in Buffer schreiben und hochz{hlen         *)
    $10/$ed/           (*        djnz Loop2           Zeile auswerten       *)
    $e1/               (*        pop  hl              Adresse zur}ck        *)
    $01/$50/$00/       (*        ld   bc,80           Zeileninc.            *)
    $09/               (*        add  hl,bc                                 *)
    $c1/               (*        pop  bc              Z{hler  zur}ck        *)
    $0d/               (*        dec  c               alle Zeilen durch?    *)
    $20/$e2            (*        jr   nz,Loop1                              *)
    );
end;

procedure LoadScreen (x,y,b,h:byte; Buff:integer);
var Pos:integer;
begin
  Pos := y*80 + x;
  Inline(
    $3a/b/             (*        ld   a,(b)           Breite des Bereiches  *)
    $47/               (*        ld   b,a             nach B                *)
    $3a/h/             (*        ld   a,(h)           H|he                  *)
    $4f/               (*        ld   c,a             nach C                *)
    $ed/$5b/$f411/     (*        ld   de,(0f411h)     VRAM-Startoffset      *)
    $19/               (*        add  hl,de           Cursoradresse         *)
    $ed/$5b/Buff/      (*        ld   de,(Buff)       Bufferadresse         *)

    $c5/               (* Loop1: push bc              Z{hler retten         *)
    $e5/               (*        push hl              Adresse retten        *)
    $1a/               (* Loop2: ld   a,(de)          Zeichen holen         *)
    $d3/$32/           (*        out  (32h),a         Zeichen rausschreiben *)
    $13/               (*        inc  de              Buffer hochz{hlen     *)
    $1a/$13/           (*        aus Buffer lesen und hochz{hlen            *)
    $d3/$33/           (*        out  (33h),a         Attribut raus         *)
    $7c/               (*        ld   a,h             Hi-Byte ausgeben      *)
    $e6/$1f/           (*        and  1f                                    *)
    $f6/$e0/           (*        or   0e0h                                  *)
    $d3/$31/           (*        out  (31h),a                               *)
    $7d/               (*        ld   a,l             jetzt Lo-Byte         *)
    $d3/$30/           (*        out  (30h),a         der Adresse raus      *)
    $23/               (*        inc  hl              Adresse +1            *)
    $10/$eb/           (*        djnz Loop2           Zeile auswerten       *)
    $e1/               (*        pop  hl              Adresse zur}ck        *)
    $01/$50/$00/       (*        ld   bc,80           Zeileninc.            *)
    $09/               (*        add  hl,bc                                 *)
    $c1/               (*        pop  bc              Z{hler  zur}ck        *)
    $0d/               (*        dec  c               alle Zeilen durch?    *)
    $20/$e0            (*        jr   nz,Loop1                              *)
    );
end;


procedure OpenWindow (x,y,b,h:byte; Rahmen:boolean);
var k:byte;

  procedure PushWindow;
  begin
    if Top >= MaxWindow then begin
      write(^G'OpenWindow: Max. ',MaxWindow,' Windows m|glich'^X);
      halt
    end;
    with WindowStack(.Window.) do begin
      xc0 := xc; yc0 := yc
    end;
    Top := succ(Top);
    Window := Top;
  end;  (* PushWindow *)

begin (* OpenWindow *)
  if (x>79) or (y>23) or (Rahmen and ((b<3) or (h<3))) or
     ((not Rahmen) and ((b<1) or (h<1))) or
     (x+b>80) or (y+h>24) or
     ((MaxInt+2*b*h) > (MaxInt+MemAvail)) then begin
       write(^g'OpenWindow: Falsche Windowparameter oder'+
               ' zuwenig Heapplatz frei'^X);
       halt
     end;
     wx := x; wy := y; wb := b; wh := h;
     PushWindow;
     with WindowStack(.Top.) do begin
       xc0 :=  0; yc0 :=  0;
       wb0 := wb; wh0 := wh;
       wx0 := wx; wy0 := wy; R := Rahmen;
       GetMem(Buffer,wb*wh*2);
       SaveScreen(wx,wy,wb,wh,ord(Buffer))
     end;
     k := Attribut;
     write(^f^j);
     if Rahmen then begin
       SetWindow(x+1,y+1,b-2,h-2);
       Zeichne_Rahmen(x,y,b-2,h-2);
     end else
       SetWindow(x,y,b,h);
     write(^f,chr(k));
     ClrScr;
end;


procedure ChangeWindow(WindowNr:byte);
begin
  if (WindowNr<1) or (WindowNr>Top) then begin
    write(^g'ChangeWindow: Window ',WindowNr,' existiert nicht'^X);
    halt
  end;
  with WindowStack(.Window.) do begin
    xc0 := xc; yc0 := yc
  end;
  Window := WindowNr;
  with WindowStack(.Window.) do begin
    wx := wx0; wy := wy0;
    wb := wb0; wh := wh0;
    if R then
      SetWindow(wx0+1,wy0+1,wb0-2,wh0-2)
    else
      SetWindow(wx0,wy0,wb0,wh0);
    gotoxy(xc0,yc0)
  end;
end;


procedure MoveWindow(x,y:byte);
var ZwBuff:^integer;
    xa, ya: byte;
begin
  if (Top<1) or (x>79) or (y>23) or
     (x+wb>80) or (y+wb>80) then begin
    write(^g'MoveWindow: Verschieben unm|glich'^X);
    halt
  end;
  ChangeWindow(Top);
  xa := xc; ya := yc;
  GetMem(ZwBuff,wb*wh*2);
  SaveScreen(wx,wy,wb,wh,ord(ZwBuff));
  with WindowStack(.Top.) do begin
    LoadScreen(wx,wy,wb,wh,ord(Buffer));
    wx  := x; wy  := y;
    wx0 := x; wy0 := y;
    SaveScreen(wx,wy,wb,wh,ord(Buffer));
    if R then
      SetWindow(wx+1,wy+1,wb-2,wh-2)
    else
      SetWindow(wx,wy,wb,wh);
  end;
  LoadScreen(wx,wy,wb,wh,ord(ZwBuff));
  FreeMem(ZwBuff,wb*wh*2);
  gotoxy(xa,ya)
end;

procedure TopWindow(WindowNr:byte);
var ZwBuff: array(.1..MaxWindow.) of ^integer;
    Hilf1 : WindowElement;
    Hilf2 : ^integer;
    i     : integer;
begin
  if (WindowNr<1) or (WindowNr>Top) then begin
    write(^g'TopWindow: Window ',WindowNr,' existiert nicht'^X);
    halt
  end;
  for i := Top downto WindowNr do
    with WindowStack(.i.) do begin
      GetMem(ZwBuff(.i.),wb0*wh0*2);
      SaveScreen(wx0,wy0,wb0,wh0,ord(ZwBuff(.i.)));
      LoadScreen(wx0,wy0,wb0,wh0,ord(Buffer))
    end;
  Hilf1 := WindowStack(.WindowNr.);
  WindowStack(.WindowNr.) := WindowStack(.Top.);
  WindowStack(.Top.) := Hilf1;
  Hilf2 := ZwBuff(.WindowNr.);
  ZwBuff(.WindowNr.) := ZwBuff(.Top.);
  ZwBuff(.Top.) := Hilf2;
  for i:= WindowNr to Top do
    with WindowStack(.i.) do begin
      SaveScreen(wx0,wy0,wb0,wh0,ord(Buffer));
      LoadScreen(wx0,wy0,wb0,wh0,ord(ZwBuff(.i.)));
      FreeMem(ZwBuff(.i.),wb0*wh0*2)
    end;
  Window := WindowNr;
  ChangeWindow(Top)
end;

procedure CloseWindow;

  procedure PopWindow;
  begin
    if Top<1 then begin
      write(^g'PopWindow: Alle Fenster bereits geschlossen'^X);
      halt
    end;
    Top := pred(Top);
    Window := Top;
    with WindowStack(.Window.) do begin
      if R then
        SetWindow(wx0+1,wy0+1,wb0-2,wh0-2)
      else
        SetWindow(wx0,wy0,wb0,wh0);
      wx := wx0; wy := wy0;
      wb := wb0; wh := wh0;
      gotoxy(xc0,yc0)
    end;
  end;  (* PopWindow *)

begin (* CloseWindow *)
  ChangeWindow(Top);
  with WindowStack(.Top.) do begin
    LoadScreen(wx,wy,wb,wh,ord(Buffer));
    FreeMem(Buffer,wb*wh*2)
  end;
  PopWindow
end;
